
Core - Bug # 61900

Story # 63720 (Closed): Make class loader more robust against crashes.

Status: Resolved Priority: Should have
Author: Alexander Opitz Category: Package Manager
Created: 2014-09-26 Assigned To: Alexander Opitz
Updated: 2014-12-10 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity:
Is Regression: Yes
Sprint Focus:
Subject: ClassLoader: Stalled Lock file if ClassLoader caching fails.
Description

If creation of ClassLoader caching isn't possible, course an exception is thrown in this process, we get a stale lock file.
Also we can get a unclean cache, as in the example the ClassAliases cache isn't saved but we don't check this again.

Example shortened backtrace what may happening:

Fatal error:  Uncaught exception 'BadFunctionCallException' with  message 'TYPO3 Fatal Error: Extension key
"external_import" is NOT  loaded!' in 
/typo3/sysext/core/Classes/Utility/ExtensionManagementUtility.php:122 
Stack  trace:
#0  /typo3conf/ext/ppi_..._showtime/ext_autoload.php(4):  
TYPO3/CMS/Core/Utility/ExtensionManagementUtility::extPath('external_import',  'interfaces/inte...')
#1  /typo3/sysext/core/Classes/Package/Package.php(292):  require('/...')
#2  /typo3/sysext/core/Classes/Core/ClassLoader.php(570): 
TYPO3/CMS/Core/Package/Package->getClassFilesFromAutoloadRegistry()
#3  /typo3/sysext/core/Classes/Core/ClassLoader.php(496):  
TYPO3/CMS/Core/Core/ClassLoader->loadClassFilesFromAutoloadRegistryIntoRuntimeClassInformationCache(Array)
#4   /typo3/sysext/core/Classes/Core/ClassLoader.php(452): 
TYPO3/CMS/Core/Core/ClassLoader->buildPackageNamespacesAndCl in
/typo3/sysext/core/Classes/Utility/ExtensionManagementUtility.php on line 122

This example happened after git updating an extension which now depends on another extension which isn't installed. Afterwards the
ClassLoader cache was cleared.

Related issues:
related to Core - Bug # 57463: Upgrading 6.2: PHP Fatal error: Could not acqu... Resolved 2014-03-31
related to Core - Task # 62852: Bring back class aliases to prevent Fatal Error Resolved 2014-11-11
related to Core - Bug # 63683: ClassLoader: Stalled Lock file if ClassLoader ... Resolved 2014-12-08

Associated revisions
Revision ab0aa415 - 2014-11-14 13:12 - Alexander Opitz

[BUGFIX] ClassLoader: Clear after Exception

Clearing the class cache and release the lock if an exception was
thrown while generating the class loader cache.
Resolves: #61900
Releases: master, 6.2
Change-Id: Iaac534e9cf333fe29f9ac90aed118cc953f857fe
Reviewed-on: http://review.typo3.org/32982
Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>
Reviewed-by: Oliver Hader <oliver.hader@typo3.org>
Tested-by: Oliver Hader <oliver.hader@typo3.org>

Revision 5b1fa3df - 2014-11-14 15:46 - Alexander Opitz

[BUGFIX] ClassLoader: Clear after Exception

Clearing the class cache and release the lock if an exception was
thrown while generating the class loader cache.

Resolves: #61900
Releases: master, 6.2
Change-Id: Iaac534e9cf333fe29f9ac90aed118cc953f857fe
Reviewed-on: http://review.typo3.org/34162
Reviewed-by: Oliver Hader <oliver.hader@typo3.org>
Tested-by: Oliver Hader <oliver.hader@typo3.org>

History
#1 - 2014-09-26 09:34 - Alexander Opitz
- Description updated

#2 - 2014-09-26 09:42 - Alexander Opitz
- Description updated

#3 - 2014-09-26 09:57 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32982

#4 - 2014-11-14 13:13 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/34162

#5 - 2014-11-14 13:31 - Alexander Opitz
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:ab0aa415529b55cd390e248c66935fa0931d62ee.
#6 - 2014-12-09 23:43 - Alexander Opitz
- Status changed from Resolved to Accepted

#7 - 2014-12-09 23:44 - Alexander Opitz
- Status changed from Accepted to Resolved

#8 - 2014-12-10 18:13 - Mathias Schreiber
- Parent task set to #63720
